Index: trunk/NEMOGCM/NEMO/TOP_SRC/trcdta.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 2715)
@@ -23,13 +23,14 @@
    PRIVATE
 
-   PUBLIC trc_dta   ! called in trcini.F90 and trcdmp.F90
+   PUBLIC   trc_dta         ! called in trcini.F90 and trcdmp.F90
+   PUBLIC   trc_dta_alloc   ! called in nemogcm.F90
 
    LOGICAL , PUBLIC, PARAMETER ::   lk_dtatrc = .TRUE.   !: temperature data flag
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk,jptra) ::   trdta   !: tracer data at given time-step
-
-   REAL(wp), DIMENSION(jpi,jpj,jpk,jptra,2) ::   tracdta            ! tracer data at two consecutive times
-   INTEGER , DIMENSION(jptra) ::   nlectr      !: switch for reading once
-   INTEGER , DIMENSION(jptra) ::   ntrc1       !: number of first month when reading 12 monthly value
-   INTEGER , DIMENSION(jptra) ::   ntrc2       !: number of second month when reading 12 monthly value
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::   trdta   !: tracer data at given time-step
+
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:,:,:) ::   tracdta       ! tracer data at two consecutive times
+   INTEGER , ALLOCATABLE, SAVE, DIMENSION(:) ::   nlectr      !: switch for reading once
+   INTEGER , ALLOCATABLE, SAVE, DIMENSION(:) ::   ntrc1       !: number of 1st month when reading 12 monthly value
+   INTEGER , ALLOCATABLE, SAVE, DIMENSION(:) ::   ntrc2       !: number of 2nd month when reading 12 monthly value
 
    !! * Substitutions
@@ -38,5 +39,5 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
@@ -55,5 +56,5 @@
       !!      two monthly values.
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt     ! ocean time-step
+      INTEGER, INTENT(in) ::   kt     ! ocean time-step
       !!
       CHARACTER (len=39) ::   clname(jptra)
@@ -198,4 +199,17 @@
    END SUBROUTINE trc_dta
 
+
+   INTEGER FUNCTION trc_dta_alloc()
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE trc_dta_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( trdta  (jpi,jpj,jpk,jptra  ) ,                    &
+         &      tracdta(jpi,jpj,jpk,jptra,2) ,                    &
+         &      nlectr(jptra) , ntrc1(jptra) , ntrc2(jptra) , STAT=trc_dta_alloc)
+         !
+      IF( trc_dta_alloc /= 0 )   CALL ctl_warn('trc_dta_alloc : failed to allocate arrays')
+      !
+   END FUNCTION trc_dta_alloc
+
 #else
    !!----------------------------------------------------------------------
Index: trunk/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 2715)
@@ -4,8 +4,8 @@
    !! TOP :   Manage the passive tracer initialization
    !!======================================================================
-   !! History :    -   !  1991-03  ()  original code
-   !!             1.0  !  2005-03 (O. Aumont, A. El Moussaoui) F90
-   !!              -   !  2005-10 (C. Ethe) print control
-   !!             2.0  !  2005-10 (C. Ethe, G. Madec) revised architecture
+   !! History :   -   ! 1991-03 (O. Marti)  original code
+   !!            1.0  ! 2005-03 (O. Aumont, A. El Moussaoui) F90
+   !!            2.0  ! 2005-10 (C. Ethe, G. Madec) revised architecture
+   !!            4.0  ! 2011-01 (A. R. Porter, STFC Daresbury) dynamical allocation
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -13,6 +13,6 @@
    !!   'key_top'                                                TOP models
    !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !!   trc_init :   Initialization for passive tracer
+   !!   trc_init  :   Initialization for passive tracer
+   !!   top_alloc :   allocate the TOP arrays
    !!----------------------------------------------------------------------
    USE oce_trc
@@ -26,12 +26,7 @@
    USE trcini_my_trc   ! MY_TRC   initialisation
    USE trcdta   
-#if defined key_offline
    USE daymod
-#endif
    USE zpshde          ! partial step: hor. derivative   (zps_hde routine)
-   USE in_out_manager  ! I/O manager
    USE prtctl_trc      ! Print control passive tracers (prt_ctl_trc_init routine)
-   USE lib_mpp         ! distributed memory computing library
-   USE lib_fortran     ! 
    
    IMPLICIT NONE
@@ -42,5 +37,9 @@
     !! * Substitutions
 #  include "domzgr_substitute.h90"
-  
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 4.0 , NEMO Consortium (2011)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
    
@@ -59,5 +58,4 @@
       INTEGER ::   jk, jn    ! dummy loop indices
       CHARACTER (len=25) :: charout
-
       !!---------------------------------------------------------------------
 
@@ -66,10 +64,12 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~'
 
-      !                 ! masked grid volume
+      CALL top_alloc()              ! allocate TOP arrays
+
+      !                             ! masked grid volume
       DO jk = 1, jpk
          cvol(:,:,jk) = e1t(:,:) * e2t(:,:) * fse3t(:,:,jk) * tmask(:,:,jk) 
       END DO
 
-      ! total volume of the ocean
+      !                             ! total volume of the ocean
 #if ! defined key_degrad
       areatot = glob_sum( cvol(:,:,:) )
@@ -78,16 +78,18 @@
 #endif
 
-                                  CALL trc_nam      ! read passive tracers namelists
-
-      ! restart for passive tracer (input)
+      CALL trc_nam                  ! read passive tracers namelists
+
+      !                             ! restart for passive tracer (input)
       IF( ln_rsttr ) THEN
          IF(lwp) WRITE(numout,*) '       read a restart file for passive tracer : ', cn_trcrst_in
          IF(lwp) WRITE(numout,*) ' '
       ELSE
-         IF(lwp) WRITE(numout,*)
-         DO jn = 1, jptra
-            IF( lwp .AND. lutini(jn) )  &                  ! open input FILE only IF lutini(jn) is true
-            &  WRITE(numout,*) '        read an initial file  for passive tracer number :', jn, ' traceur : ', ctrcnm(jn) 
-         END DO
+         IF( lwp .AND. lk_dtatrc ) THEN
+            DO jn = 1, jptra
+               IF( lutini(jn) )  &                  ! open input FILE only IF lutini(jn) is true
+                  &  WRITE(numout,*) ' read an initial file for passive tracer number :', jn, ' traceur : ', ctrcnm(jn) 
+             END DO
+          ENDIF
+          IF( lwp ) WRITE(numout,*)
       ENDIF
 
@@ -138,12 +140,12 @@
       ENDIF
  
-      tra(:,:,:,:) = 0.
+      tra(:,:,:,:) = 0._wp
       
       IF( ln_zps .AND. .NOT. lk_c1d )   &              ! Partial steps: before horizontal gradient of passive
-      &                     CALL zps_hde( nit000, jptra, trn, gtru, gtrv )       ! tracers at the bottom ocean level
-
-
-      !                 ! Computation content of all tracers
-      trai = 0.e0
+        &    CALL zps_hde( nit000, jptra, trn, gtru, gtrv )       ! tracers at the bottom ocean level
+
+
+      !           
+      trai = 0._wp         ! Computation content of all tracers
       DO jn = 1, jptra
 #if ! defined key_degrad
@@ -154,22 +156,72 @@
       END DO      
 
-      !                 ! control print
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '          *** Total number of passive tracer jptra = ', jptra
-      IF(lwp) WRITE(numout,*) '          *** Total volume of ocean                = ', areatot
-      IF(lwp) WRITE(numout,*) '          *** Total inital content of all tracers  = ', trai
-      IF(lwp) WRITE(numout,*)
-
-      IF( ln_ctl )   CALL prt_ctl_trc_init      ! control print
-      !
-
-      IF(ln_ctl) THEN      ! print mean trends (used for debugging)
+      IF(lwp) THEN               ! control print
+         WRITE(numout,*)
+         WRITE(numout,*)
+         WRITE(numout,*) '          *** Total number of passive tracer jptra = ', jptra
+         WRITE(numout,*) '          *** Total volume of ocean                = ', areatot
+         WRITE(numout,*) '          *** Total inital content of all tracers  = ', trai
+         WRITE(numout,*)
+      ENDIF
+
+      IF(ln_ctl) THEN            ! print mean trends (used for debugging)
+         CALL prt_ctl_trc_init
          WRITE(charout, FMT="('ini ')")
          CALL prt_ctl_trc_info( charout )
          CALL prt_ctl_trc( tab4d=trn, mask=tmask, clinfo=ctrcnm )
       ENDIF
-
+      !
    END SUBROUTINE trc_init
+
+
+   SUBROUTINE top_alloc
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE top_alloc  ***
+      !!
+      !! ** Purpose :   Allocate all the dynamic arrays of the OPA modules
+      !!----------------------------------------------------------------------
+      USE trcadv        , ONLY:   trc_adv_alloc          ! TOP-related alloc routines...
+      USE trc           , ONLY:   trc_alloc
+      USE trcnxt        , ONLY:   trc_nxt_alloc
+      USE trczdf        , ONLY:   trc_zdf_alloc
+      USE trdmod_trc_oce, ONLY:   trd_mod_trc_oce_alloc
+#if ! defined key_iomput
+      USE trcdia        , ONLY:   trc_dia_alloc
+#endif
+#if defined key_trcdmp 
+      USE trcdmp        , ONLY:   trc_dmp_alloc
+#endif
+#if defined key_dtatrc
+      USE trcdta        , ONLY:   trc_dta_alloc
+#endif
+#if defined key_trdmld_trc   ||   defined key_esopa
+      USE trdmld_trc    , ONLY:   trd_mld_trc_alloc
+#endif
+      !
+      INTEGER :: ierr
+      !!----------------------------------------------------------------------
+      !
+      ierr =        trc_adv_alloc()          ! Start of TOP-related alloc routines...
+      ierr = ierr + trc_alloc    ()
+      ierr = ierr + trc_nxt_alloc()
+      ierr = ierr + trc_zdf_alloc()
+      ierr = ierr + trd_mod_trc_oce_alloc()
+#if ! defined key_iomput
+      ierr = ierr + trc_dia_alloc()
+#endif
+#if defined key_trcdmp 
+      ierr = ierr + trc_dmp_alloc()
+#endif
+#if defined key_dtatrc
+      ierr = ierr + trc_dta_alloc()
+#endif
+#if defined key_trdmld_trc   ||   defined key_esopa
+      ierr = ierr + trd_mld_trc_alloc()
+#endif
+      !
+      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'top_alloc : unable to allocate standard ocean arrays' )
+      !
+   END SUBROUTINE top_alloc
 
 #else
@@ -182,8 +234,4 @@
 #endif
 
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE trcini
Index: trunk/NEMOGCM/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2715)
@@ -26,5 +26,4 @@
    USE trcnam_c14b       ! C14 SMS namelist
    USE trcnam_my_trc     ! MY_TRC SMS namelist
-   USE in_out_manager    ! I/O manager
    USE trdmod_trc_oce
 
@@ -103,9 +102,9 @@
 
       DO jn = 1, jptra
-         ctrcnm(jn) = sn_tracer(jn)%clsname
-         ctrcnl(jn) = sn_tracer(jn)%cllname
-         ctrcun(jn) = sn_tracer(jn)%clunit
-         lutini(jn) = sn_tracer(jn)%llinit
-         lutsav(jn) = sn_tracer(jn)%llsave
+         ctrcnm(jn) = TRIM( sn_tracer(jn)%clsname )
+         ctrcnl(jn) = TRIM( sn_tracer(jn)%cllname )
+         ctrcun(jn) = TRIM( sn_tracer(jn)%clunit  )
+         lutini(jn) =       sn_tracer(jn)%llinit 
+         lutsav(jn) =       sn_tracer(jn)%llsave
       END DO
 
@@ -121,7 +120,7 @@
          DO jn = 1, jptra
             WRITE(numout,*) '   tracer nb             : ', jn 
-            WRITE(numout,*) '   short name            : ', TRIM(ctrcnm(jn))
-            WRITE(numout,*) '   long name             : ', TRIM(ctrcnl(jn))
-            WRITE(numout,*) '   unit                  : ', TRIM(ctrcun(jn))
+            WRITE(numout,*) '   short name            : ', ctrcnm(jn)
+            WRITE(numout,*) '   long name             : ', ctrcnl(jn)
+            WRITE(numout,*) '   unit                  : ', ctrcun(jn)
             WRITE(numout,*) '   initial value in FILE : ', lutini(jn) 
             WRITE(numout,*) ' '
Index: trunk/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 2715)
@@ -26,6 +26,4 @@
    USE trc
    USE trcnam_trp
-   USE lib_mpp
-   USE lib_fortran
    USE iom
    USE trcrst_cfc      ! CFC      
